; ======================================================;
;                                                       ;
;  winioctl.inc for Easy Code 2.0 64-bit Masm projects  ;
;                    (version 1.0.0)                    ;
;                                                       ;
;             Copyright  Ramon Sala - 2022             ;
;                                                       ;
; ======================================================;

IFNDEF WINIOCTL_INC
WINIOCTL_INC     EQU     1

WINIOCTL_H_REQVER                               EQU     100

GUID_DiskClassGuid                              EQU     {053F56307H, 0B6BFH, 011D0H, {094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH}}
GUID_CdRomClassGuid                             EQU     {053F56308H, 0B6BFH, 011D0H, {094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH}}
GUID_PartitionClassGuid                         EQU     {053F5630aH, 0B6BFH, 011D0H, {094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH}}
GUID_TapeClassGuid                              EQU     {053F5630bH, 0B6BFH, 011D0H, {094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH}}
GUID_WriteOnceDiskClassGuid                     EQU     {053F5630cH, 0B6BFH, 011D0H, {094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH}}
GUID_VolumeClassGuid                            EQU     {053F5630dH, 0B6BFH, 011D0H, {094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH}}
GUID_MediumChangerClassGuid                     EQU     {053F56310H, 0B6BFH, 011D0H, {094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH}}
GUID_FloppyClassGuid                            EQU     {053F56311H, 0B6BFH, 011D0H, {094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH}}
GUID_CdChangerClassGuid                         EQU     {053F56312H, 0B6BFH, 011D0H, {094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH}}
GUID_StoragePortClassGuid                       EQU     {02ACCFE60H, 0C130H, 011D2H, {0B0H, 082H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH}}

GUID_GUID_CLASS_COMPORT                         EQU     {086E0D1E0H, 08089H, 011D0H, {09CH, 0E4H, 008H, 000H, 03EH, 030H, 01FH, 073H}}
GUID_GUID_SERENUM_BUS_ENUMERATOR                EQU     {04D36E978H, 0E325H, 011CEH, {0BFH, 0C1H, 008H, 000H, 02BH, 0E1H, 003H, 018H}}

IFNDEF FILE_DEVICE_BEEP
    FILE_DEVICE_BEEP                            EQU     000000001H
    FILE_DEVICE_CD_ROM                          EQU     000000002H
    FILE_DEVICE_CD_ROM_FILE_SYSTEM              EQU     000000003H
    FILE_DEVICE_CONTROLLER                      EQU     000000004H
    FILE_DEVICE_DATALINK                        EQU     000000005H
    FILE_DEVICE_DFS                             EQU     000000006H
    FILE_DEVICE_DISK                            EQU     000000007H
    FILE_DEVICE_DISK_FILE_SYSTEM                EQU     000000008H
    FILE_DEVICE_FILE_SYSTEM                     EQU     000000009H
    FILE_DEVICE_INPORT_PORT                     EQU     00000000AH
    FILE_DEVICE_KEYBOARD                        EQU     00000000BH
    FILE_DEVICE_MAILSLOT                        EQU     00000000CH
    FILE_DEVICE_MIDI_IN                         EQU     00000000DH
    FILE_DEVICE_MIDI_OUT                        EQU     00000000EH
    FILE_DEVICE_MOUSE                           EQU     00000000FH
    FILE_DEVICE_MULTI_UNC_PROVIDER              EQU     000000010H
    FILE_DEVICE_NAMED_PIPE                      EQU     000000011H
    FILE_DEVICE_NETWORK                         EQU     000000012H
    FILE_DEVICE_NETWORK_BROWSER                 EQU     000000013H
    FILE_DEVICE_NETWORK_FILE_SYSTEM             EQU     000000014H
    FILE_DEVICE_NULL                            EQU     000000015H
    FILE_DEVICE_PARALLEL_PORT                   EQU     000000016H
    FILE_DEVICE_PHYSICAL_NETCARD                EQU     000000017H
    FILE_DEVICE_PRINTER                         EQU     000000018H
    FILE_DEVICE_SCANNER                         EQU     000000019H
    FILE_DEVICE_SERIAL_MOUSE_PORT               EQU     00000001AH
    FILE_DEVICE_SERIAL_PORT                     EQU     00000001BH
    FILE_DEVICE_SCREEN                          EQU     00000001CH
    FILE_DEVICE_SOUND                           EQU     00000001DH
    FILE_DEVICE_STREAMS                         EQU     00000001EH
    FILE_DEVICE_TAPE                            EQU     00000001FH
    FILE_DEVICE_TAPE_FILE_SYSTEM                EQU     000000020H
    FILE_DEVICE_TRANSPORT                       EQU     000000021H
    FILE_DEVICE_UNKNOWN                         EQU     000000022H
    FILE_DEVICE_VIDEO                           EQU     000000023H
    FILE_DEVICE_VIRTUAL_DISK                    EQU     000000024H
    FILE_DEVICE_WAVE_IN                         EQU     000000025H
    FILE_DEVICE_WAVE_OUT                        EQU     000000026H
    FILE_DEVICE_8042_PORT                       EQU     000000027H
    FILE_DEVICE_NETWORK_REDIRECTOR              EQU     000000028H
    FILE_DEVICE_BATTERY                         EQU     000000029H
    FILE_DEVICE_BUS_EXTENDER                    EQU     00000002AH
    FILE_DEVICE_MODEM                           EQU     00000002BH
    FILE_DEVICE_VDM                             EQU     00000002CH
    FILE_DEVICE_MASS_STORAGE                    EQU     00000002DH
    FILE_DEVICE_SMB                             EQU     00000002EH
    FILE_DEVICE_KS                              EQU     00000002FH
    FILE_DEVICE_CHANGER                         EQU     000000030H
    IFNDEF FILE_DEVICE_SMARTCARD
        FILE_DEVICE_SMARTCARD                   EQU     000000031H
    ENDIF
    FILE_DEVICE_ACPI                            EQU     000000032H
    FILE_DEVICE_DVD                             EQU     000000033H
    FILE_DEVICE_FULLSCREEN_VIDEO                EQU     000000034H
    FILE_DEVICE_DFS_FILE_SYSTEM                 EQU     000000035H
    FILE_DEVICE_DFS_VOLUME                      EQU     000000036H
    FILE_DEVICE_SERENUM                         EQU     000000037H
    FILE_DEVICE_TERMSRV                         EQU     000000038H
    FILE_DEVICE_KSEC                            EQU     000000039H
    FILE_DEVICE_FIPS                            EQU     00000003AH
    FILE_DEVICE_INFINIBAND                      EQU     00000003BH
    FILE_DEVICE_VMBUS                           EQU     00000003EH
    FILE_DEVICE_CRYPT_PROVIDER                  EQU     00000003FH
    FILE_DEVICE_WPD                             EQU     000000040H
    FILE_DEVICE_BLUETOOTH                       EQU     000000041H
    FILE_DEVICE_MT_COMPOSITE                    EQU     000000042H
    FILE_DEVICE_MT_TRANSPORT                    EQU     000000043H
    FILE_DEVICE_BIOMETRIC                       EQU     000000044H
    FILE_DEVICE_PMI                             EQU     000000045H
ENDIF

METHOD_BUFFERED                                 EQU     0
METHOD_IN_DIRECT                                EQU     1
METHOD_OUT_DIRECT                               EQU     2
METHOD_NEITHER                                  EQU     3

FILE_ANY_ACCESS                                 EQU     0
FILE_SPECIAL_ACCESS                             EQU     FILE_ANY_ACCESS
FILE_READ_ACCESS                                EQU     00001H
FILE_WRITE_ACCESS                               EQU     00002H

IOCTL_STORAGE_BASE                              EQU     FILE_DEVICE_MASS_STORAGE
IOCTL_STORAGE_CHECK_VERIFY                      EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00200H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_STORAGE_CHECK_VERIFY2                     EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00200H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_STORAGE_MEDIA_REMOVAL                     EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00201H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_STORAGE_EJECT_MEDIA                       EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00202H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_STORAGE_LOAD_MEDIA                        EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00203H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_STORAGE_LOAD_MEDIA2                       EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00203H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_STORAGE_RESERVE                           EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00204H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_STORAGE_RELEASE                           EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00205H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_STORAGE_FIND_NEW_DEVICES                  EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00206H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_STORAGE_EJECTION_CONTROL                  EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00250H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_STORAGE_MCN_CONTROL                       EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00251H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_STORAGE_GET_MEDIA_TYPES                   EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00300H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_STORAGE_GET_MEDIA_TYPES_EX                EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00301H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_STORAGE_RESET_BUS                         EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00400H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_STORAGE_RESET_DEVICE                      EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00401H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_STORAGE_GET_DEVICE_NUMBER                 EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00420H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_STORAGE_PREDICT_FAILURE                   EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00440H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_STORAGE_BREAK_RESERVATION                 EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00405H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_STORAGE_PERSISTENT_RESERVE_IN             EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00406H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_STORAGE_PERSISTENT_RESERVE_OUT            EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00407H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_STORAGE_READ_CAPACITY                     EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00450H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_STORAGE_QUERY_PROPERTY                    EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00500H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_STORAGE_GET_BC_PROPERTIES                 EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00600H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_STORAGE_ALLOCATE_BC_STREAM                EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00601H SHL 2) OR METHOD_BUFFERED OR ((FILE_READ_ACCESS OR FILE_WRITE_ACCESS) SHL 14)
IOCTL_STORAGE_FREE_BC_STREAM                    EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00602H SHL 2) OR METHOD_BUFFERED OR ((FILE_READ_ACCESS OR FILE_WRITE_ACCESS) SHL 14)
IOCTL_STORAGE_CHECK_PRIORITY_HINT_SUPPORT       EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00620H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)

OBSOLETE_IOCTL_STORAGE_RESET_BUS                EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00400H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
OBSOLETE_IOCTL_STORAGE_RESET_DEVICE             EQU     (IOCTL_STORAGE_BASE SHL 16) OR (00401H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)

IOCTL_DISK_BASE                                 EQU     FILE_DEVICE_DISK
IOCTL_DISK_GET_DRIVE_GEOMETRY                   EQU     (IOCTL_DISK_BASE SHL 16) OR (00000H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_DISK_GET_PARTITION_INFO                   EQU     (IOCTL_DISK_BASE SHL 16) OR (00001H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_DISK_SET_PARTITION_INFO                   EQU     (IOCTL_DISK_BASE SHL 16) OR (00002H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_DISK_GET_DRIVE_LAYOUT                     EQU     (IOCTL_DISK_BASE SHL 16) OR (00003H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_DISK_SET_DRIVE_LAYOUT                     EQU     (IOCTL_DISK_BASE SHL 16) OR (00004H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_DISK_VERIFY                               EQU     (IOCTL_DISK_BASE SHL 16) OR (00005H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_DISK_FORMAT_TRACKS                        EQU     (IOCTL_DISK_BASE SHL 16) OR (00006H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_DISK_REASSIGN_BLOCKS                      EQU     (IOCTL_DISK_BASE SHL 16) OR (00007H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_DISK_PERFORMANCE                          EQU     (IOCTL_DISK_BASE SHL 16) OR (00008H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_DISK_IS_WRITABLE                          EQU     (IOCTL_DISK_BASE SHL 16) OR (00009H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_DISK_LOGGING                              EQU     (IOCTL_DISK_BASE SHL 16) OR (0000AH SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_DISK_FORMAT_TRACKS_EX                     EQU     (IOCTL_DISK_BASE SHL 16) OR (0000BH SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_DISK_HISTOGRAM_STRUCTURE                  EQU     (IOCTL_DISK_BASE SHL 16) OR (0000CH SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_DISK_HISTOGRAM_DATA                       EQU     (IOCTL_DISK_BASE SHL 16) OR (0000DH SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_DISK_HISTOGRAM_RESET                      EQU     (IOCTL_DISK_BASE SHL 16) OR (0000EH SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_DISK_REQUEST_STRUCTURE                    EQU     (IOCTL_DISK_BASE SHL 16) OR (0000FH SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_DISK_REQUEST_DATA                         EQU     (IOCTL_DISK_BASE SHL 16) OR (00010H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_DISK_CONTROLLER_NUMBER                    EQU     (IOCTL_DISK_BASE SHL 16) OR (00011H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
SMART_GET_VERSION                               EQU     (IOCTL_DISK_BASE SHL 16) OR (00020H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
SMART_SEND_DRIVE_COMMAND                        EQU     (IOCTL_DISK_BASE SHL 16) OR (00021H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
SMART_RCV_DRIVE_DATA                            EQU     (IOCTL_DISK_BASE SHL 16) OR (00022H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_DISK_UPDATE_DRIVE_SIZE                    EQU     (IOCTL_DISK_BASE SHL 16) OR (00032H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_DISK_GROW_PARTITION                       EQU     (IOCTL_DISK_BASE SHL 16) OR (00034H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_DISK_GET_CACHE_INFORMATION                EQU     (IOCTL_DISK_BASE SHL 16) OR (00035H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_DISK_SET_CACHE_INFORMATION                EQU     (IOCTL_DISK_BASE SHL 16) OR (00036H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_DISK_DELETE_DRIVE_LAYOUT                  EQU     (IOCTL_DISK_BASE SHL 16) OR (00040H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_DISK_FORMAT_DRIVE                         EQU     (IOCTL_DISK_BASE SHL 16) OR (000F3H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_DISK_SENSE_DEVICE                         EQU     (IOCTL_DISK_BASE SHL 16) OR (000F8H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_DISK_CHECK_VERIFY                         EQU     (IOCTL_DISK_BASE SHL 16) OR (00200H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_DISK_MEDIA_REMOVAL                        EQU     (IOCTL_DISK_BASE SHL 16) OR (00201H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_DISK_EJECT_MEDIA                          EQU     (IOCTL_DISK_BASE SHL 16) OR (00202H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_DISK_LOAD_MEDIA                           EQU     (IOCTL_DISK_BASE SHL 16) OR (00203H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_DISK_RESERVE                              EQU     (IOCTL_DISK_BASE SHL 16) OR (00204H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_DISK_RELEASE                              EQU     (IOCTL_DISK_BASE SHL 16) OR (00205H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_DISK_FIND_NEW_DEVICES                     EQU     (IOCTL_DISK_BASE SHL 16) OR (00206H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_DISK_GET_MEDIA_TYPES                      EQU     (IOCTL_DISK_BASE SHL 16) OR (00300H SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_DISK_GET_WRITE_CACHE_STATE                EQU     (IOCTL_DISK_BASE SHL 16) OR (00037H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
OBSOLETE_DISK_GET_WRITE_CACHE_STATE             EQU     (IOCTL_DISK_BASE SHL 16) OR (00037H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)


IOCTL_CHANGER_BASE                              EQU     FILE_DEVICE_CHANGER
IOCTL_CHANGER_GET_PARAMETERS                    EQU     (IOCTL_CHANGER_BASE SHL 16) OR (00000H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_CHANGER_GET_STATUS                        EQU     (IOCTL_CHANGER_BASE SHL 16) OR (00001H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_CHANGER_GET_PRODUCT_DATA                  EQU     (IOCTL_CHANGER_BASE SHL 16) OR (00002H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_CHANGER_SET_ACCESS                        EQU     (IOCTL_CHANGER_BASE SHL 16) OR (00004H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_CHANGER_GET_ELEMENT_STATUS                EQU     (IOCTL_CHANGER_BASE SHL 16) OR (00005H SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_CHANGER_INITIALIZE_ELEMENT_STATUS         EQU     (IOCTL_CHANGER_BASE SHL 16) OR (00006H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_CHANGER_SET_POSITION                      EQU     (IOCTL_CHANGER_BASE SHL 16) OR (00007H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_CHANGER_EXCHANGE_MEDIUM                   EQU     (IOCTL_CHANGER_BASE SHL 16) OR (00008H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_CHANGER_MOVE_MEDIUM                       EQU     (IOCTL_CHANGER_BASE SHL 16) OR (00009H SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_CHANGER_REINITIALIZE_TRANSPORT            EQU     (IOCTL_CHANGER_BASE SHL 16) OR (0000AH SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)
IOCTL_CHANGER_QUERY_VOLUME_TAGS                 EQU     (IOCTL_CHANGER_BASE SHL 16) OR (0000BH SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
IOCTL_VOLUME_IS_CLUSTERED                       EQU     (IOCTL_VOLUME_BASE SHL 16) OR (0000CH SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)

RECOVERED_WRITES_VALID                          EQU     000000001H
UNRECOVERED_WRITES_VALID                        EQU     000000002H
RECOVERED_READS_VALID                           EQU     000000004H
UNRECOVERED_READS_VALID                         EQU     000000008H
WRITE_COMPRESSION_INFO_VALID                    EQU     000000010H
READ_COMPRESSION_INFO_VALID                     EQU     000000020H

TAPE_RETURN_STATISTICS                          EQU     0
TAPE_RETURN_ENV_INFO                            EQU     1
TAPE_RESET_STATISTICS                           EQU     2

MEDIA_ERASEABLE                                 EQU     000000001H
MEDIA_WRITE_ONCE                                EQU     000000002H
MEDIA_READ_ONLY                                 EQU     000000004H
MEDIA_READ_WRITE                                EQU     000000008H

MEDIA_WRITE_PROTECTED                           EQU     000000100H
MEDIA_CURRENTLY_MOUNTED                         EQU     080000000H

DDS_4mm                                         EQU     32
MiniQic                                         EQU     33
Travan                                          EQU     34
QIC                                             EQU     35
MP_8mm                                          EQU     36
AME_8mm                                         EQU     37
AIT1_8mm                                        EQU     38
DLT                                             EQU     39
NCTP                                            EQU     40
IBM_3480                                        EQU     41
IBM_3490E                                       EQU     42
IBM_Magstar_3590                                EQU     43
IBM_Magstar_MP                                  EQU     44
STK_DATA_D3                                     EQU     45
SONY_DTF                                        EQU     46
DV_6mm                                          EQU     47
DMI                                             EQU     48
SONY_D2                                         EQU     49
CLEANER_CARTRIDGE                               EQU     50
CD_ROM                                          EQU     51
CD_R                                            EQU     52
CD_RW                                           EQU     53
DVD_ROM                                         EQU     54
DVD_R                                           EQU     55
DVD_RW                                          EQU     56
MO_3_RW                                         EQU     57
MO_5_WO                                         EQU     58
MO_5_RW                                         EQU     59
MO_5_LIMDOW                                     EQU     60
PC_5_WO                                         EQU     61
PC_5_RW                                         EQU     62
PD_5_RW                                         EQU     63
ABL_5_WO                                        EQU     64
PINNACLE_APEX_5_RW                              EQU     65
SONY_12_WO                                      EQU     66
PHILIPS_12_WO                                   EQU     67
HITACHI_12_WO                                   EQU     68
CYGNET_12_WO                                    EQU     69
KODAK_14_WO                                     EQU     70
MO_NFR_525                                      EQU     71
NIKON_12_RW                                     EQU     72
IOMEGA_ZIP                                      EQU     73
IOMEGA_JAZ                                      EQU     74
SYQUEST_EZ135                                   EQU     75
SYQUEST_EZFLYER                                 EQU     76
SYQUEST_SYJET                                   EQU     77
AVATAR_F2                                       EQU     78
MP2_8mm                                         EQU     79
DST_S                                           EQU     80
DST_M                                           EQU     81
DST_L                                           EQU     82
VXATape_1                                       EQU     83
VXATape_2                                       EQU     84
STK_9840                                        EQU     85
STK_EAGLE                                       EQU     85
LTO_Ultrium                                     EQU     86
LTO_Accelis                                     EQU     87
DVD_RAM                                         EQU     88
AIT_8mm                                         EQU     89
ADR_1                                           EQU     90
ADR_2                                           EQU     91
STK_9940                                        EQU     92
SAIT                                            EQU     93
VXATape                                         EQU     94

BusTypeUnknown                                  EQU     0
BusTypeScsi                                     EQU     1
BusTypeAtapi                                    EQU     2
BusTypeAta                                      EQU     3
BusType1394                                     EQU     4
BusTypeSsa                                      EQU     5
BusTypeFibre                                    EQU     6
BusTypeUsb                                      EQU     7
BusTypeRAID                                     EQU     8
BusTypeiScsi                                    EQU     9
BusTypeSas                                      EQU     10
BusTypeSata                                     EQU     11
BusTypeSd                                       EQU     12
BusTypeMmc                                      EQU     13
BusTypeMax                                      EQU     14
BusTypeMaxReserved                              EQU     07FH

PARTITION_ENTRY_UNUSED                          EQU     000H
PARTITION_FAT_12                                EQU     001H
PARTITION_XENIX_1                               EQU     002H
PARTITION_XENIX_2                               EQU     003H
PARTITION_FAT_16                                EQU     004H
PARTITION_EXTENDED                              EQU     005H
PARTITION_HUGE                                  EQU     006H
PARTITION_IFS                                   EQU     007H
PARTITION_FAT32                                 EQU     00BH
PARTITION_FAT32_XINT13                          EQU     00CH
PARTITION_XINT13                                EQU     00EH
PARTITION_XINT13_EXTENDED                       EQU     00FH
PARTITION_PREP                                  EQU     041H
PARTITION_LDM                                   EQU     042H
PARTITION_UNIX                                  EQU     063H
PARTITION_NTFT                                  EQU     080H
VALID_NTFT                                      EQU     0C0H

HIST_NO_OF_BUCKETS                              EQU     24

HISTOGRAM_BUCKET_SIZE                           EQU     SizeOf HISTOGRAM_BUCKET
DISK_HISTOGRAM_SIZE                             EQU     SizeOf DISK_HISTOGRAM

DISK_LOGGING_START                              EQU     0
DISK_LOGGING_STOP                               EQU     1
DISK_LOGGING_DUMP                               EQU     2
DISK_BINNING                                    EQU     3

StoragePortCodeSetReserved                      EQU     0
StoragePortCodeSetStorport                      EQU     1
StoragePortCodeSetSCSIport                      EQU     2

StorageIdCodeSetReserved                        EQU     0
StorageIdCodeSetBinary                          EQU     1
StorageIdCodeSetAscii                           EQU     2
StorageIdCodeSetUtf8                            EQU     3

StorageIdTypeVendorSpecific                     EQU     0
StorageIdTypeVendorId                           EQU     1
StorageIdTypeEUI64                              EQU     2
StorageIdTypeFCPHName                           EQU     3
StorageIdTypePortRelative                       EQU     4
StorageIdTypeTargetPortGroup                    EQU     5
StorageIdTypeLogicalUnitGroup                   EQU     6
StorageIdTypeMD5LogicalUnitIdentifier           EQU     7
StorageIdTypeScsiNameString                     EQU     8

StorageIdTypeNAA                                EQU     StorageIdTypeFCPHName

StorageIdNAAFormatIEEEExtended                  EQU     2
StorageIdNAAFormatIEEERegistered                EQU     3
StorageIdNAAFormatIEEEERegisteredExtended       EQU     5

StorageIdAssocDevice                            EQU     0
StorageIdAssocPort                              EQU     1
StorageIdAssocTarget                            EQU     2

WriteCacheTypeUnknown                           EQU     0
WriteCacheTypeNone                              EQU     1
WriteCacheTypeWriteBack                         EQU     2
WriteCacheTypeWriteThrough                      EQU     3

WriteCacheEnableUnknown                         EQU     0
WriteCacheDisabled                              EQU     1
WriteCacheEnabled                               EQU     2

WriteCacheChangeUnknown                         EQU     0
WriteCacheNotChangeable                         EQU     1
WriteCacheChangeable                            EQU     2

WriteThroughUnknown                             EQU     0
WriteThroughNotSupported                        EQU     1
WriteThroughSupported                           EQU     2

F5_1Pt2_512                                     EQU     1
F3_1Pt44_512                                    EQU     2
F3_2Pt88_512                                    EQU     3
F3_20Pt8_512                                    EQU     4
F3_720_512                                      EQU     5
F5_360_512                                      EQU     6
F5_320_512                                      EQU     7
F5_320_1024                                     EQU     8
F5_180_512                                      EQU     9
F5_160_512                                      EQU     10
RemovableMedia                                  EQU     11
FixedMedia                                      EQU     12
F3_120M_512                                     EQU     13
F3_640_512                                      EQU     14
F5_640_512                                      EQU     15
F5_720_512                                      EQU     16
F3_1Pt2_512                                     EQU     17
F3_1Pt23_1024                                   EQU     18
F5_1Pt23_1024                                   EQU     19
F3_128Mb_512                                    EQU     20
F3_230Mb_512                                    EQU     21
F8_256_128                                      EQU     22
F3_200Mb_512                                    EQU     23
F3_240M_512                                     EQU     24
F3_32M_512                                      EQU     25

WMI_DISK_GEOMETRY_GUID                          EQU     {025007F51H, 057C2H, 011D1H, {0A5H, 028H, 00H, 0A0H, 0C9H, 06H,029H, 010H}}

PARTITION_STYLE_MBR                             EQU     0
PARTITION_STYLE_GPT                             EQU     1
PARTITION_STYLE_RAW                             EQU     2

GPT_ATTRIBUTE_PLATFORM_REQUIRED                 EQU     00000000000000001H
GPT_BASIC_DATA_ATTRIBUTE_NO_DRIVE_LETTER        EQU     08000000000000000H
GPT_BASIC_DATA_ATTRIBUTE_HIDDEN                 EQU     04000000000000000H
GPT_BASIC_DATA_ATTRIBUTE_SHADOW_COPY            EQU     02000000000000000H
GPT_BASIC_DATA_ATTRIBUTE_READ_ONLY              EQU     01000000000000000H

DetectNone                                      EQU     0
DetectInt13                                     EQU     1
DetectExInt13                                   EQU     2

EqualPriority                                   EQU     0
KeepPrefetchedData                              EQU     1
KeepReadData                                    EQU     2

DiskWriteCacheNormal                            EQU     0
DiskWriteCacheForceDisable                      EQU     1
DiskWriteCacheDisableNotSupported               EQU     2

CAP_ATA_ID_CMD                                  EQU     1
CAP_ATAPI_ID_CMD                                EQU     2
CAP_SMART_CMD                                   EQU     4

ATAPI_ID_CMD                                    EQU     0A1H
ID_CMD                                          EQU     0ECH
SMART_CMD                                       EQU     0B0H

SMART_CYL_LOW                                   EQU     04FH
SMART_CYL_HI                                    EQU     0C2H

SMART_NO_ERROR                                  EQU     0
SMART_IDE_ERROR                                 EQU     1
SMART_INVALID_FLAG                              EQU     2
SMART_INVALID_COMMAND                           EQU     3
SMART_INVALID_BUFFER                            EQU     4
SMART_INVALID_DRIVE                             EQU     5
SMART_INVALID_IOCTL                             EQU     6
SMART_ERROR_NO_MEM                              EQU     7
SMART_INVALID_REGISTER                          EQU     8
SMART_NOT_SUPPORTED                             EQU     9
SMART_NO_IDE_DEVICE                             EQU     10

READ_ATTRIBUTE_BUFFER_SIZE                      EQU     512
IDENTIFY_BUFFER_SIZE                            EQU     512
READ_THRESHOLD_BUFFER_SIZE                      EQU     512

READ_ATTRIBUTES                                 EQU     0D0H
READ_THRESHOLDS                                 EQU     0D1H
ENABLE_DISABLE_AUTOSAVE                         EQU     0D2H
SAVE_ATTRIBUTE_VALUES                           EQU     0D3H
EXECUTE_OFFLINE_DIAGS                           EQU     0D4H
ENABLE_SMART                                    EQU     0D8H
DISABLE_SMART                                   EQU     0D9H
RETURN_SMART_STATUS                             EQU     0DAH
ENABLE_DISABLE_AUTO_OFFLINE                     EQU     0DBH

MAX_VOLUME_ID_SIZE                              EQU     36
MAX_VOLUME_TEMPLATE_SIZE                        EQU     40

VENDOR_ID_LENGTH                                EQU     8
PRODUCT_ID_LENGTH                               EQU     16
REVISION_LENGTH                                 EQU     4
SERIAL_NUMBER_LENGTH                            EQU     32

AllElements                                     EQU     0
ChangerTransport                                EQU     1
ChangerSlot                                     EQU     2
ChangerIEPort                                   EQU     3
ChangerDrive                                    EQU     4
ChangerDoor                                     EQU     5
ChangerKeypad                                   EQU     6
ChangerMaxElement                               EQU     7

CHANGER_BAR_CODE_SCANNER_INSTALLED              EQU     000000001H
CHANGER_INIT_ELEM_STAT_WITH_RANGE               EQU     000000002H
CHANGER_CLOSE_IEPORT                            EQU     000000004H
CHANGER_OPEN_IEPORT                             EQU     000000008H
CHANGER_STATUS_NON_VOLATILE                     EQU     000000010H
CHANGER_EXCHANGE_MEDIA                          EQU     000000020H
CHANGER_CLEANER_SLOT                            EQU     000000040H
CHANGER_LOCK_UNLOCK                             EQU     000000080H
CHANGER_CARTRIDGE_MAGAZINE                      EQU     000000100H
CHANGER_MEDIUM_FLIP                             EQU     000000200H
CHANGER_POSITION_TO_ELEMENT                     EQU     000000400H
CHANGER_REPORT_IEPORT_STATE                     EQU     000000800H
CHANGER_STORAGE_DRIVE                           EQU     000001000H
CHANGER_STORAGE_IEPORT                          EQU     000002000H
CHANGER_STORAGE_SLOT                            EQU     000004000H
CHANGER_STORAGE_TRANSPORT                       EQU     000008000H
CHANGER_DRIVE_CLEANING_REQUIRED                 EQU     000010000H
CHANGER_PREDISMOUNT_EJECT_REQUIRED              EQU     000020000H
CHANGER_CLEANER_ACCESS_NOT_VALID                EQU     000040000H
CHANGER_PREMOUNT_EJECT_REQUIRED                 EQU     000080000H
CHANGER_VOLUME_IDENTIFICATION                   EQU     000100000H
CHANGER_VOLUME_SEARCH                           EQU     000200000H
CHANGER_VOLUME_ASSERT                           EQU     000400000H
CHANGER_VOLUME_REPLACE                          EQU     000800000H
CHANGER_VOLUME_UNDEFINE                         EQU     001000000H
CHANGER_SERIAL_NUMBER_VALID                     EQU     004000000H
CHANGER_DEVICE_REINITIALIZE_CAPABLE             EQU     008000000H
CHANGER_KEYPAD_ENABLE_DISABLE                   EQU     010000000H
CHANGER_DRIVE_EMPTY_ON_DOOR_ACCESS              EQU     020000000H
CHANGER_RESERVED_BIT                            EQU     080000000H
CHANGER_PREDISMOUNT_ALIGN_TO_SLOT               EQU     080000001H
CHANGER_PREDISMOUNT_ALIGN_TO_DRIVE              EQU     080000002H
CHANGER_CLEANER_AUTODISMOUNT                    EQU     080000004H
CHANGER_TRUE_EXCHANGE_CAPABLE                   EQU     080000008H
CHANGER_SLOTS_USE_TRAYS                         EQU     080000010H
CHANGER_RTN_MEDIA_TO_ORIGINAL_ADDR              EQU     080000020H
CHANGER_CLEANER_OPS_NOT_SUPPORTED               EQU     080000040H
CHANGER_IEPORT_USER_CONTROL_OPEN                EQU     080000080H
CHANGER_IEPORT_USER_CONTROL_CLOSE               EQU     080000100H
CHANGER_MOVE_EXTENDS_IEPORT                     EQU     080000200H
CHANGER_MOVE_RETRACTS_IEPORT                    EQU     080000400H

CHANGER_TO_TRANSPORT                            EQU     001H
CHANGER_TO_SLOT                                 EQU     002H
CHANGER_TO_IEPORT                               EQU     004H
CHANGER_TO_DRIVE                                EQU     008H

LOCK_UNLOCK_IEPORT                              EQU     001H
LOCK_UNLOCK_DOOR                                EQU     002H
LOCK_UNLOCK_KEYPAD                              EQU     004H

LOCK_ELEMENT                                    EQU     0
UNLOCK_ELEMENT                                  EQU     1
EXTEND_IEPORT                                   EQU     2
RETRACT_IEPORT                                  EQU     3

ELEMENT_STATUS_FULL                             EQU     000000001H
ELEMENT_STATUS_IMPEXP                           EQU     000000002H
ELEMENT_STATUS_EXCEPT                           EQU     000000004H
ELEMENT_STATUS_ACCESS                           EQU     000000008H
ELEMENT_STATUS_EXENAB                           EQU     000000010H
ELEMENT_STATUS_INENAB                           EQU     000000020H

ELEMENT_STATUS_LUN_VALID                        EQU     000001000H
ELEMENT_STATUS_ID_VALID                         EQU     000002000H
ELEMENT_STATUS_NOT_BUS                          EQU     000008000H
ELEMENT_STATUS_INVERT                           EQU     000400000H
ELEMENT_STATUS_SVALID                           EQU     000800000H

ELEMENT_STATUS_PVOLTAG                          EQU     010000000H
ELEMENT_STATUS_AVOLTAG                          EQU     020000000H

ERROR_LABEL_UNREADABLE                          EQU     000000001H
ERROR_LABEL_QUESTIONABLE                        EQU     000000002H
ERROR_SLOT_NOT_PRESENT                          EQU     000000004H
ERROR_DRIVE_NOT_INSTALLED                       EQU     000000008H
ERROR_TRAY_MALFUNCTION                          EQU     000000010H
ERROR_INIT_STATUS_NEEDED                        EQU     000000011H
ERROR_UNHANDLED_ERROR                           EQU     0FFFFFFFFH

SEARCH_ALL                                      EQU     00H
SEARCH_PRIMARY                                  EQU     01H
SEARCH_ALTERNATE                                EQU     02H
SEARCH_ALL_NO_SEQ                               EQU     04H
SEARCH_PRI_NO_SEQ                               EQU     05H
SEARCH_ALT_NO_SEQ                               EQU     06H

ASSERT_PRIMARY                                  EQU     08H
ASSERT_ALTERNATE                                EQU     09H

REPLACE_PRIMARY                                 EQU     0AH
REPLACE_ALTERNATE                               EQU     0BH

UNDEFINE_PRIMARY                                EQU     0CH
UNDEFINE_ALTERNATE                              EQU     0DH

DeviceProblemNone                               EQU     0
DeviceProblemHardware                           EQU     1
DeviceProblemCHMError                           EQU     2
DeviceProblemDoorOpen                           EQU     3
DeviceProblemCalibrationError                   EQU     4
DeviceProblemTargetFailure                      EQU     5
DeviceProblemCHMMoveError                       EQU     6
DeviceProblemCHMZeroError                       EQU     7
DeviceProblemCartridgeInsertError               EQU     8
DeviceProblemPositionError                      EQU     9
DeviceProblemSensorError                        EQU     10
DeviceProblemCartridgeEjectError                EQU     11
DeviceProblemGripperError                       EQU     12
DeviceProblemDriveError                         EQU     13

FILE_DEVICE_AVIO                                EQU     099H

IOCTL_AVIO_ALLOCATE_STREAM                      EQU     (FILE_DEVICE_AVIO SHL 16) OR (1 SHL 2) OR METHOD_BUFFERED OR (FILE_SPECIAL_ACCESS SHL 14)
IOCTL_AVIO_FREE_STREAM                          EQU     (FILE_DEVICE_AVIO SHL 16) OR (2 SHL 2) OR METHOD_BUFFERED OR (FILE_SPECIAL_ACCESS SHL 14)
IOCTL_AVIO_MODIFY_STREAM                        EQU     (FILE_DEVICE_AVIO SHL 16) OR (3 SHL 2) OR METHOD_BUFFERED OR (FILE_SPECIAL_ACCESS SHL 14)

IOCTL_SERIAL_LSRMST_INSERT                      EQU     (FILE_DEVICE_SERIAL_PORT SHL 16) OR (31 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_SERENUM_EXPOSE_HARDWARE                   EQU     (FILE_DEVICE_SERENUM SHL 16) OR (128 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_SERENUM_REMOVE_HARDWARE                   EQU     (FILE_DEVICE_SERENUM SHL 16) OR (129 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_SERENUM_PORT_DESC                         EQU     (FILE_DEVICE_SERENUM SHL 16) OR (130 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
IOCTL_SERENUM_GET_PORT_NAME                     EQU     (FILE_DEVICE_SERENUM SHL 16) OR (131 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)

SERIAL_LSRMST_ESCAPE                            EQU     0
SERIAL_LSRMST_LSR_DATA                          EQU     1
SERIAL_LSRMST_LSR_NODATA                        EQU     2
SERIAL_LSRMST_MST                               EQU     3

SERIAL_IOC_FCR_FIFO_ENABLE                      EQU     000000001H
SERIAL_IOC_FCR_RCVR_RESET                       EQU     000000002H
SERIAL_IOC_FCR_XMIT_RESET                       EQU     000000004H
SERIAL_IOC_FCR_DMA_MODE                         EQU     000000008H
SERIAL_IOC_FCR_RES1                             EQU     000000010H
SERIAL_IOC_FCR_RES2                             EQU     000000020H
SERIAL_IOC_FCR_RCVR_TRIGGER_LSB                 EQU     000000040H
SERIAL_IOC_FCR_RCVR_TRIGGER_MSB                 EQU     000000080H

SERIAL_IOC_MCR_DTR                              EQU     000000001H
SERIAL_IOC_MCR_RTS                              EQU     000000002H
SERIAL_IOC_MCR_OUT1                             EQU     000000004H
SERIAL_IOC_MCR_OUT2                             EQU     000000008H
SERIAL_IOC_MCR_LOOP                             EQU     000000010H

FSCTL_REQUEST_OPLOCK_LEVEL_1                    EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (0 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_REQUEST_OPLOCK_LEVEL_2                    EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (1 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_REQUEST_BATCH_OPLOCK                      EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (2 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_OPLOCK_BREAK_ACKNOWLEDGE                  EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (3 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_OPBATCH_ACK_CLOSE_PENDING                 EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (4 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_OPLOCK_BREAK_NOTIFY                       EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (5 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_LOCK_VOLUME                               EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (6 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_UNLOCK_VOLUME                             EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (7 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_DISMOUNT_VOLUME                           EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (8 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_IS_VOLUME_MOUNTED                         EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (10 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_IS_PATHNAME_VALID                         EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (11 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_MARK_VOLUME_DIRTY                         EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (12 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_QUERY_RETRIEVAL_POINTERS                  EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (14 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_GET_COMPRESSION                           EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (15 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_SET_COMPRESSION                           EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (16 SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
FSCTL_MARK_AS_SYSTEM_HIVE                       EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (19 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_OPLOCK_BREAK_ACK_NO_2                     EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (20 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_INVALIDATE_VOLUMES                        EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (21 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_QUERY_FAT_BPB                             EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (22 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_REQUEST_FILTER_OPLOCK                     EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (23 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_FILESYSTEM_GET_STATISTICS                 EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (24 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_GET_NTFS_VOLUME_DATA                      EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (25 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_GET_NTFS_FILE_RECORD                      EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (26 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_GET_VOLUME_BITMAP                         EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (27 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_GET_RETRIEVAL_POINTERS                    EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (28 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_MOVE_FILE                                 EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (29 SHL 2) OR METHOD_BUFFERED OR (FILE_SPECIAL_ACCESS SHL 14)
FSCTL_IS_VOLUME_DIRTY                           EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (30 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_GET_HFS_INFORMATION                       EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (31 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_ALLOW_EXTENDED_DASD_IO                    EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (32 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_READ_PROPERTY_DATA                        EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (33 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_WRITE_PROPERTY_DATA                       EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (34 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_FIND_FILES_BY_SID                         EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (35 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_DUMP_PROPERTY_DATA                        EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (37 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_SET_OBJECT_ID                             EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (38 SHL 2) OR METHOD_BUFFERED OR (FILE_SPECIAL_ACCESS SHL 14)
FSCTL_GET_OBJECT_ID                             EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (39 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_DELETE_OBJECT_ID                          EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (40 SHL 2) OR METHOD_BUFFERED OR (FILE_SPECIAL_ACCESS SHL 14)
FSCTL_SET_REPARSE_POINT                         EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (41 SHL 2) OR METHOD_BUFFERED OR (FILE_SPECIAL_ACCESS SHL 14)
FSCTL_GET_REPARSE_POINT                         EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (42 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_DELETE_REPARSE_POINT                      EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (43 SHL 2) OR METHOD_BUFFERED OR (FILE_SPECIAL_ACCESS SHL 14)
FSCTL_ENUM_USN_DATA                             EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (44 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_SECURITY_ID_CHECK                         EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (45 SHL 2) OR METHOD_NEITHER OR (FILE_READ_ACCESS SHL 14)
FSCTL_READ_USN_JOURNAL                          EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (46 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_SET_OBJECT_ID_EXTENDED                    EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (47 SHL 2) OR METHOD_BUFFERED OR (FILE_SPECIAL_ACCESS SHL 14)
FSCTL_CREATE_OR_GET_OBJECT_ID                   EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (48 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_SET_SPARSE                                EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (49 SHL 2) OR METHOD_BUFFERED OR (FILE_SPECIAL_ACCESS SHL 14)
FSCTL_SET_ZERO_DATA                             EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (50 SHL 2) OR METHOD_BUFFERED OR (FILE_WRITE_ACCESS SHL 14)
FSCTL_QUERY_ALLOCATED_RANGES                    EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (51 SHL 2) OR METHOD_NEITHER OR (FILE_READ_ACCESS SHL 14)
FSCTL_ENABLE_UPGRADE                            EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (52 SHL 2) OR METHOD_BUFFERED OR (FILE_WRITE_ACCESS SHL 14)
FSCTL_SET_ENCRYPTION                            EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (53 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_ENCRYPTION_FSCTL_IO                       EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (54 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_WRITE_RAW_ENCRYPTED                       EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (55 SHL 2) OR METHOD_NEITHER OR (FILE_SPECIAL_ACCESS SHL 14)
FSCTL_READ_RAW_ENCRYPTED                        EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (56 SHL 2) OR METHOD_NEITHER OR (FILE_SPECIAL_ACCESS SHL 14)
FSCTL_CREATE_USN_JOURNAL                        EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (57 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_READ_FILE_USN_DATA                        EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (58 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_WRITE_USN_CLOSE_RECORD                    EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (59 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_EXTEND_VOLUME                             EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (60 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_QUERY_USN_JOURNAL                         EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (61 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_DELETE_USN_JOURNAL                        EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (62 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_MARK_HANDLE                               EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (63 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_SIS_COPYFILE                              EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (64 SHL 2) OR METHOD_BUFFERED OR (FILE_ANY_ACCESS SHL 14)
FSCTL_SIS_LINK_FILES                            EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (65 SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
FSCTL_HSM_MSG                                   EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (66 SHL 2) OR METHOD_BUFFERED OR (FILE_READWRITE_ACCESS SHL 14)
FSCTL_NSS_CONTROL                               EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (67 SHL 2) OR METHOD_BUFFERED OR (FILE_WRITE_ACCESS SHL 14)
FSCTL_HSM_DATA                                  EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (68 SHL 2) OR METHOD_NEITHER OR (FILE_READWRITE_ACCESS SHL 14)
FSCTL_RECALL_FILE                               EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (69 SHL 2) OR METHOD_NEITHER OR (FILE_ANY_ACCESS SHL 14)
FSCTL_NSS_RCONTROL                              EQU     (FILE_DEVICE_FILE_SYSTEM SHL 16) OR (70 SHL 2) OR METHOD_BUFFERED OR (FILE_READ_ACCESS SHL 14)

USN_PAGE_SIZE                                   EQU     01000H

USN_REASON_DATA_OVERWRITE                       EQU     000000001H
USN_REASON_DATA_EXTEND                          EQU     000000002H
USN_REASON_DATA_TRUNCATION                      EQU     000000004H
USN_REASON_NAMED_DATA_OVERWRITE                 EQU     000000010H
USN_REASON_NAMED_DATA_EXTEND                    EQU     000000020H
USN_REASON_NAMED_DATA_TRUNCATION                EQU     000000040H
USN_REASON_FILE_CREATE                          EQU     000000100H
USN_REASON_FILE_DELETE                          EQU     000000200H
USN_REASON_EA_CHANGE                            EQU     000000400H
USN_REASON_SECURITY_CHANGE                      EQU     000000800H
USN_REASON_RENAME_OLD_NAME                      EQU     000001000H
USN_REASON_RENAME_NEW_NAME                      EQU     000002000H
USN_REASON_INDEXABLE_CHANGE                     EQU     000004000H
USN_REASON_BASIC_INFO_CHANGE                    EQU     000008000H
USN_REASON_HARD_LINK_CHANGE                     EQU     000010000H
USN_REASON_COMPRESSION_CHANGE                   EQU     000020000H
USN_REASON_ENCRYPTION_CHANGE                    EQU     000040000H
USN_REASON_OBJECT_ID_CHANGE                     EQU     000080000H
USN_REASON_REPARSE_POINT_CHANGE                 EQU     000100000H
USN_REASON_STREAM_CHANGE                        EQU     000200000H
USN_REASON_CLOSE                                EQU     080000000H

USN_DELETE_FLAG_DELETE                          EQU     000000001H
USN_DELETE_FLAG_NOTIFY                          EQU     000000002H
USN_DELETE_VALID_FLAGS                          EQU     000000003H

USN_SOURCE_DATA_MANAGEMENT                      EQU     000000001H
USN_SOURCE_AUXILIARY_DATA                       EQU     000000002H
USN_SOURCE_REPLICATION_MANAGEMENT               EQU     000000004H

VOLUME_IS_DIRTY                                 EQU     000000001H
VOLUME_UPGRADE_SCHEDULED                        EQU     000000002H

FILESYSTEM_STATISTICS_TYPE_NTFS                 EQU     1
FILESYSTEM_STATISTICS_TYPE_FAT                  EQU     2

FILE_SET_ENCRYPTION                             EQU     000000001H
FILE_CLEAR_ENCRYPTION                           EQU     000000002H
STREAM_SET_ENCRYPTION                           EQU     000000003H
STREAM_CLEAR_ENCRYPTION                         EQU     000000004H

MAXIMUM_ENCRYPTION_VALUE                        EQU     000000004H

ENCRYPTION_FORMAT_DEFAULT                       EQU     001H
COMPRESSION_FORMAT_SPARSE                       EQU     04000H

COPYFILE_SIS_LINK                               EQU     00001H
COPYFILE_SIS_REPLACE                            EQU     00002H
COPYFILE_SIS_FLAGS                              EQU     00003H

NSS_CONTROL_MARK                                EQU     1
NSS_CONTROL_UNMARK                              EQU     2
NSS_CONTROL_ISNSSFILE                           EQU     4

IOCTL_VOLUME_BASE                               EQU     <V>
IOCTL_VOLUME_GET_VOLUME_DISK_EXTENTS            EQU     (IOCTL_VOLUME_BASE SHL 16) OR (0 SHL 2)OR METHOD_BUFFEREDOR (FILE_ANY_ACCESS SHL 14)

STORAGE_PRIORITY_HINT_SUPPORTED                 EQU     00001H

;======================================== Structures ======================================;
STORAGE_DEVICE_NUMBER STRUCT ALIGNMODE
    DeviceType      DD ?
    DeviceNumber    DD ?
    PartitionNumber DD ?
STORAGE_DEVICE_NUMBER ENDS

STORAGE_BUS_RESET_REQUEST STRUCT ALIGNMODE
    PathId DB ?
STORAGE_BUS_RESET_REQUEST ENDS

PREVENT_MEDIA_REMOVAL STRUCT ALIGNMODE
    PreventMediaRemoval DD ?
PREVENT_MEDIA_REMOVAL ENDS

TAPE_STATISTICS STRUCT ALIGNMODE
    Version                DD ?
    iFlags                 DD ?
    RecoveredWrites        LARGE_INTEGER <>
    UnrecoveredWrites      LARGE_INTEGER <>
    RecoveredReads         LARGE_INTEGER <>
    UnrecoveredReads       LARGE_INTEGER <>
    CompressionRatioReads  DB ?
    CompressionRatioWrites DB ?
TAPE_STATISTICS ENDS

TAPE_GET_STATISTICS STRUCT ALIGNMODE
    Operation DD ?
TAPE_GET_STATISTICS ENDS

DEVICE_MEDIA_INFO STRUCT ALIGNMODE
    UNION
        STRUCT DiskInfo
            Cylinders            LARGE_INTEGER <>
            MediaType            DD ?
            TracksPerCylinder    DD ?
            SectorsPerTrack      DD ?
            BytesPerSector       DD ?
            NumberMediaSides     DD ?
            MediaCharacteristics DD ?
        ENDS
        STRUCT RemovableDiskInfo
            Cylinders            LARGE_INTEGER <>
            MediaType            DD ?
            TracksPerCylinder    DD ?
            SectorsPerTrack      DD ?
            BytesPerSector       DD ?
            NumberMediaSides     DD ?
            MediaCharacteristics DD ?
        ENDS
        STRUCT TapeInfo
            MediaType            DD ?
            MediaCharacteristics DD ?
            CurrentBlockSize     DD ?
            BusType              DD ?
            STRUCT ScsiInformation
                MediumType       DB ?
                DensityCode      DB ?
            ENDS
        ENDS
    ENDS
DEVICE_MEDIA_INFO ENDS

GET_MEDIA_TYPES STRUCT ALIGNMODE
    DeviceType     DD ?
    MediaInfoCount DD ?
    MediaInfo      DEVICE_MEDIA_INFO <>
GET_MEDIA_TYPES ENDS

STORAGE_PREDICT_FAILURE STRUCT ALIGNMODE
    PredictFailure DD ?
    VendorSpecific DB 512 DUP(?)
STORAGE_PREDICT_FAILURE ENDS

IFNDEF STORAGE_ADAPTER_DESCRIPTOR
    STORAGE_ADAPTER_DESCRIPTOR STRUCT ALIGNMODE
        Version               DD ?
        _Size                 DD ?
        MaximumTransferLength DD ?
        MaximumPhysicalPages  DD ?
        AlignmentMask         DD ?
        AdapterUsesPio        DB ?
        AdapterScansDown      DB ?
        CommandQueueing       DB ?
        AcceleratedTransfer   DB ?
        BusType               DB ?
        BusMajorVersion       DW ?
        BusMinorVersion       DW ?
    STORAGE_ADAPTER_DESCRIPTOR ENDS
ENDIF

STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR STRUCT ALIGNMODE
    Version                       DD ?
    _Size                         DD ?
    BytesPerCacheLine             DD ?
    BytesOffsetForCacheAlignment  DD ?
    BytesPerLogicalSector         DD ?
    BytesPerPhysicalSector        DD ?
    BytesOffsetForSectorAlignment DD ?
STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR ENDS

STORAGE_MINIPORT_DESCRIPTOR STRUCT ALIGNMODE
    Version              DD ?
    _Size                DD ?
    Portdriver           DD ?
    LUNResetSupported    DB ?
    TargetResetSupported DB ?
STORAGE_MINIPORT_DESCRIPTOR ENDS

STORAGE_IDENTIFIER STRUCT ALIGNMODE
    CodeSet        DD ?
    _Type          DD ?
    IdentifierSize DW ?
    NextOffset     DW ?
    Association    DD ?
    Identifier     DB ?
STORAGE_IDENTIFIER ENDS

STORAGE_DEVICE_ID_DESCRIPTOR STRUCT ALIGNMODE
    Version             DD ?
    _Size               DD ?
    NumberOfIdentifiers DD ?
    Identifiers         DB ?
STORAGE_DEVICE_ID_DESCRIPTOR ENDS

STORAGE_GET_BC_PROPERTIES_OUTPUT STRUCT ALIGNMODE
    MaximumRequestsPerPeriod DD ?
    MinimumPeriod            DD ?
    MaximumRequestSize       DQ ?
    EstimatedTimePerRequest  DD ?
    NumOutStandingRequests   DD ?
    RequestSize              DQ ?
STORAGE_GET_BC_PROPERTIES_OUTPUT ENDS

STORAGE_ALLOCATE_BC_STREAM_INPUT STRUCT ALIGNMODE
    Version           DD ?
    RequestsPerPeriod DD ?
    Period            DD ?
    RetryFailures     DB ?
    Discardable       DB ?
    Reserved1         DB 2 DUP(?)
    AccessType        DD ?
    AccessMode        DD ?
STORAGE_ALLOCATE_BC_STREAM_INPUT ENDS

STORAGE_ALLOCATE_BC_STREAM_OUTPUT STRUCT ALIGNMODE
    RequestSize            DQ ?
    NumOutStandingRequests DD ?
STORAGE_ALLOCATE_BC_STREAM_OUTPUT ENDS

STORAGE_PRIORITY_HINT_SUPPORT STRUCT ALIGNMODE
    SupportFlags DD ?
STORAGE_PRIORITY_HINT_SUPPORT ENDS

STORAGE_MEDIA_SERIAL_NUMBER_DATA STRUCT ALIGNMODE
    Reserved           DW ?
    SerialNumberLength DW ?
    SerialNumber       DB ?
STORAGE_MEDIA_SERIAL_NUMBER_DATA ENDS

STORAGE_READ_CAPACITY STRUCT ALIGNMODE
    Version        DD ?
    _Size          DD ?
    BlockLength    DD ?
    NumberOfBlocks LARGE_INTEGER <>
    DiskLength     LARGE_INTEGER <>
STORAGE_READ_CAPACITY ENDS

STORAGE_WRITE_CACHE_PROPERTY STRUCT ALIGNMODE
    Version                    DD ?
    _Size                      DD ?
    WriteCacheType             DD ?
    _WriteCacheEnabled         DD ?
    _WriteCacheChangeable      DD ?
    _WriteThroughSupported     DD ?
    FlushCacheSupported        DB ?
    UserDefinedPowerProtection DB ?
    NVCacheEnabled             DB ?
STORAGE_WRITE_CACHE_PROPERTY ENDS

PERSISTENT_RESERVE_COMMAND STRUCT ALIGNMODE
    Version                  DD ?
    _Size                    DD ?
    UNION
        STRUCT PR_IN
            ServiceAction    DB ?
            Reserved1        DB ?
            AllocationLength DW ?
        ENDS
        STRUCT PR_OUT
            ServiceAction    DB ?
            _Type            DB ?
            Scope            DB ?
            ParameterList    DB ?
        ENDS
    ENDS
PERSISTENT_RESERVE_COMMAND ENDS

FORMAT_PARAMETERS STRUCT ALIGNMODE
    MediaType           DD ?
    StartCylinderNumber DD ?
    EndCylinderNumber   DD ?
    StartHeadNumber     DD ?
    EndHeadNumber       DD ?
FORMAT_PARAMETERS ENDS

FORMAT_EX_PARAMETERS STRUCT ALIGNMODE
    MediaType           DD ?
    StartCylinderNumber DD ?
    EndCylinderNumber   DD ?
    StartHeadNumber     DD ?
    EndHeadNumber       DD ?
    FormatGapLength     DW ?
    SectorsPerTrack     DW ?
    SectorNumber        DW ?
FORMAT_EX_PARAMETERS ENDS

DISK_GEOMETRY STRUCT ALIGNMODE
    Cylinders         DQ ?
    MediaType         DD ?
    TracksPerCylinder DD ?
    SectorsPerTrack   DD ?
    BytesPerSector    DD ?
DISK_GEOMETRY ENDS

PARTITION_INFORMATION STRUCT ALIGNMODE
    StartingOffset      DQ ?
    PartitionLength     DQ ?
    HiddenSectors       DD ?
    PartitionNumber     DD ?
    PartitionType       DB ?
    BootIndicator       DD ?
    RecognizedPartition DD ?
    RewritePartition    DD ?
PARTITION_INFORMATION ENDS

SET_PARTITION_INFORMATION STRUCT ALIGNMODE
    PartitionType DB ?
SET_PARTITION_INFORMATION ENDS

SET_PARTITION_INFORMATION_MBR TYPEDEF SET_PARTITION_INFORMATION

DRIVE_LAYOUT_INFORMATION STRUCT ALIGNMODE
    PartitionCount DD ?
    Signature      DD ?
    PartitionEntry PARTITION_INFORMATION <>
DRIVE_LAYOUT_INFORMATION ENDS

VERIFY_INFORMATION STRUCT ALIGNMODE
    StartingOffset DQ ?
    _Length        DD ?
VERIFY_INFORMATION ENDS

REASSIGN_BLOCKS STRUCT ALIGNMODE
    Reserved    DW ?
    Count       DW ?
    BlockNumber DD ?
REASSIGN_BLOCKS ENDS

DISK_CONTROLLER_NUMBER STRUCT ALIGNMODE
    ControllerNumber DD ?
    DiskNumber       DD ?
DISK_CONTROLLER_NUMBER ENDS

VOLUME_COMPRESSION_STATE STRUCT ALIGNMODE
    CompressNewFiles DD ?
VOLUME_COMPRESSION_STATE ENDS

PARTITION_INFORMATION_GPT STRUCT ALIGNMODE
    PartitionType GUID <>
    PartitionId   GUID <>
    Attributes    DQ ?
    _Name         DW 36 DUP(?)
PARTITION_INFORMATION_GPT ENDS

SET_PARTITION_INFORMATION_GPT TYPEDEF PARTITION_INFORMATION_GPT

PARTITION_INFORMATION_MBR STRUCT ALIGNMODE
    PartitionType       DB ?
    BootIndicator       DB ?
    RecognizedPartition DB ?
    HiddenSectors       DD ?
PARTITION_INFORMATION_MBR ENDS

SET_PARTITION_INFORMATION_EX STRUCT ALIGNMODE
    PartitionStyle DD ?
    UNION
        Mbr SET_PARTITION_INFORMATION_MBR <>
        Gpt SET_PARTITION_INFORMATION_GPT <>
    ENDS
SET_PARTITION_INFORMATION_EX ENDS

CREATE_DISK_GPT STRUCT ALIGNMODE
    DiskId            GUID <>
    MaxPartitionCount DD ?
CREATE_DISK_GPT ENDS

CREATE_DISK_MBR STRUCT ALIGNMODE
    Signature DD ?
CREATE_DISK_MBR ENDS

CREATE_DISK STRUCT ALIGNMODE
    PartitionStyle          DD ?
    UNION
        Mbr CREATE_DISK_MBR <>
        Gpt CREATE_DISK_GPT <>
    ENDS
CREATE_DISK ENDS

GET_LENGTH_INFORMATION STRUCT ALIGNMODE
    _Length LARGE_INTEGER <>
GET_LENGTH_INFORMATION ENDS

PARTITION_INFORMATION_EX STRUCT ALIGNMODE
    PartitionStyle   DD ?
    StartingOffset   LARGE_INTEGER <>
    PartitionLength  LARGE_INTEGER <>
    PartitionNumber  DD ?
    RewritePartition DB ?
    UNION
        Mbr PARTITION_INFORMATION_MBR <>
        Gpt PARTITION_INFORMATION_GPT <>
    ENDS
PARTITION_INFORMATION_EX ENDS

DRIVE_LAYOUT_INFORMATION_GPT STRUCT ALIGNMODE
    DiskId               GUID <>
    StartingUsableOffset LARGE_INTEGER <>
    UsableLength         LARGE_INTEGER <>
    MaxPartitionCount    DD ?
DRIVE_LAYOUT_INFORMATION_GPT ENDS

DRIVE_LAYOUT_INFORMATION_MBR STRUCT ALIGNMODE
    Signature DD ?
DRIVE_LAYOUT_INFORMATION_MBR ENDS

DRIVE_LAYOUT_INFORMATION_EX STRUCT ALIGNMODE
    PartitionStyle DD ?
    PartitionCount DD ?
    UNION
        Mbr PARTITION_INFORMATION_MBR <>
        Gpt PARTITION_INFORMATION_GPT <>
    ENDS
    PartitionEntry PARTITION_INFORMATION_EX <>
DRIVE_LAYOUT_INFORMATION_EX ENDS

DISK_INT13_INFO STRUCT ALIGNMODE
    DriveSelect     DW ?
    MaxCylinders    DD ?
    SectorsPerTrack DW ?
    MaxHeads        DW ?
    NumberDrives    DW ?
DISK_INT13_INFO ENDS

DISK_EX_INT13_INFO STRUCT ALIGNMODE
    ExBufferSize      DW ?
    ExFlags           DW ?
    ExCylinders       DD ?
    ExHeads           DD ?
    ExSectorsPerTrack DD ?
    ExSectorsPerDrive DQ ?
    ExSectorSize      DW ?
    ExReserved        DW ?
DISK_EX_INT13_INFO ENDS

DISK_DETECTION_INFO STRUCT ALIGNMODE
    SizeOfDetectInfo DD ?
    DetectionType    DD ?
    UNION
        STRUCT
            Int13    DISK_INT13_INFO <>
            ExInt13  DISK_EX_INT13_INFO <>
        ENDS
    ENDS
DISK_DETECTION_INFO ENDS

DISK_PARTITION_INFO STRUCT ALIGNMODE
    SizeOfPartitionInfo DD ?
    PartitionStyle      DD ?
    UNION
        STRUCT Mbr
            Signature   DD ?
            CheckSum    DD ?
        ENDS
        STRUCT Gpt
            DiskId      GUID <>
        ENDS
    ENDS
DISK_PARTITION_INFO ENDS

DISK_GEOMETRY_EX STRUCT ALIGNMODE
    Geometry DISK_GEOMETRY <>
    DiskSize LARGE_INTEGER <>
    Data     DB ?
DISK_GEOMETRY_EX ENDS

IFNDEF DISK_CONTROLLER_NUMBER
    DISK_CONTROLLER_NUMBER Struct ALIGNMODE
        ControllerNumber DD ?
        DiskNumber       DD ?
    DISK_CONTROLLER_NUMBER EndS
ENDIF

DISK_CACHE_INFORMATION STRUCT ALIGNMODE
    ParametersSavable             DD ?
    ReadCacheEnabled              DD ?
    _WriteCacheEnabled            DD ?
    ReadRetentionPriority         DD ?
    WriteRetentionPriority        DD ?
    DisablePrefetchTransferLength DW ?
    PrefetchScalar                DD ?
    UNION
        STRUCT ScalarPrefetch
            Minimum               DW ?
            Maximum               DW ?
            MaximumBlocks         DW ?
        ENDS
        STRUCT BlockPrefetch
            Minimum               DW ?
            Maximum               DW ?
        ENDS
    ENDS
DISK_CACHE_INFORMATION ENDS

DISK_GROW_PARTITION STRUCT ALIGNMODE
    PartitionNumber DD ?
    BytesToGrow     DQ ?
DISK_GROW_PARTITION ENDS

HISTOGRAM_BUCKET STRUCT ALIGNMODE
    Reads  DD ?
    Writes DD ?
HISTOGRAM_BUCKET ENDS

DISK_HISTOGRAM STRUCT ALIGNMODE
    DiskSize     DQ ?
    Start        DQ ?
    _End         DQ ?
    Average      DQ ?
    AverageRead  DQ ?
    AverageWrite DQ ?
    Granularity  DD ?
    _Size        DD ?
    ReadCount    DD ?
    WriteCount   DD ?
    Histogram    DD ?
DISK_HISTOGRAM ENDS

DISK_PERFORMANCE STRUCT ALIGNMODE
    BytesRead           DQ ?
    BytesWritten        DQ ?
    ReadTime            DQ ?
    WriteTime           DQ ?
    IdleTime            DQ ?
    ReadCount           DD ?
    WriteCount          DD ?
    QueueDepth          DD ?
    SplitCount          DD ?
    QueryTime           DQ ?
    StorageDeviceNumber DD ?
    StorageManagerName  DW 8 DUP(?)
DISK_PERFORMANCE ENDS

DISK_RECORD STRUCT ALIGNMODE
    ByteOffset     DQ ?
    StartTime      DQ ?
    EndTime        DQ ?
    VirtualAddress DD ?
    NumberOfBytes  DD ?
    DeviceNumber   DB ?
    ReadRequest    DD ?
DISK_RECORD ENDS

DISK_LOGGING STRUCT ALIGNMODE
    Function      DB ?
    BufferAddress DD ?
    BufferSize    DD ?
DISK_LOGGING ENDS

ENUM_BIN_TYPES STRUCT ALIGNMODE
    RequestSize     DB ?
    RequestLocation DB ?
ENUM_BIN_TYPES ENDS

BIN_RANGE STRUCT ALIGNMODE
    StartValue DQ ?
    _Length    DQ ?
BIN_RANGE ENDS

PERF_BIN STRUCT ALIGNMODE
    NumberOfBins DD ?
    TypeOfBin    DD ?
    BinsRanges   BIN_RANGE <>
PERF_BIN ENDS

BIN_COUNT STRUCT ALIGNMODE
    BinRange BIN_RANGE <>
    BinCount DD ?
BIN_COUNT ENDS

BIN_RESULTS STRUCT ALIGNMODE
    NumberOfBins DD ?
    BinCounts    BIN_RANGE <>
BIN_RESULTS ENDS

GETVERSIONINPARAMS STRUCT ALIGNMODE
    bVersion      DB ?
    bRevision     DB ?
    bReserved     DB ?
    bIDEDeviceMap DB ?
    fCapabilities DD ?
    dwReserved    DD 4 DUP(?)
GETVERSIONINPARAMS ENDS

IDEREGS STRUCT ALIGNMODE
    bFeaturesReg     DB ?
    bSectorCountReg  DB ?
    bSectorNumberReg DB ?
    bCylLowReg       DB ?
    bCylHighReg      DB ?
    bDriveHeadReg    DB ?
    bCommandReg      DB ?
    bReserved        DB ?
IDEREGS ENDS

SENDCMDINPARAMS STRUCT ALIGNMODE
    cBufferSize  DD ?
    irDriveRegs  IDEREGS <>
    bDriveNumber DB ?
    bReserved    DB 3 DUP(?)
    dwReserved   DD 4 DUP(?)
    bBuffer      DB ?
SENDCMDINPARAMS ENDS

DRIVERSTATUS STRUCT ALIGNMODE
    bDriverError DB ?
    bIDEError    DB ?
    bReserved    DB 2 DUP(?)
    dwReserved   DD 2 DUP(?)
DRIVERSTATUS ENDS

SENDCMDOUTPARAMS STRUCT ALIGNMODE
    cBufferSize  DD ?
    DriverStatus DRIVERSTATUS <>
    bBuffer      DB ?
SENDCMDOUTPARAMS ENDS

CHANGER_ELEMENT STRUCT ALIGNMODE
    ElementType    DD ?
    ElementAddress DD ?
CHANGER_ELEMENT ENDS

CHANGER_ELEMENT_LIST STRUCT ALIGNMODE
    Element          CHANGER_ELEMENT <>
    NumberOfElements DD ?
CHANGER_ELEMENT_LIST ENDS

GET_CHANGER_PARAMETERS STRUCT ALIGNMODE
    _Size                      DD ?
    NumberTransportElements    DW ?
    NumberStorageElements      DW ?
    NumberCleanerSlots         DW ?
    NumberIEElements           DW ?
    NumberDataTransferElements DW ?
    NumberOfDoors              DW ?
    FirstSlotNumber            DW ?
    FirstDriveNumber           DW ?
    FirstTransportNumber       DW ?
    FirstIEPortNumber          DW ?
    FirstCleanerSlotAddress    DW ?
    MagazineSize               DW ?
    DriveCleanTimeout          DD ?
    Features0                  DD ?
    Features1                  DD ?
    MoveFromTransport          DB ?
    MoveFromSlot               DB ?
    MoveFromIePort             DB ?
    MoveFromDrive              DB ?
    ExchangeFromTransport      DB ?
    ExchangeFromSlot           DB ?
    ExchangeFromIePort         DB ?
    ExchangeFromDrive          DB ?
    LockUnlockCapabilities     DB ?
    PositionCapabilities       DB ?
    Reserved1                  DB 2 DUP(?)
    Reserved2                  DD 2 DUP(?)
GET_CHANGER_PARAMETERS ENDS

CHANGER_PRODUCT_DATA STRUCT ALIGNMODE
    VendorId     DB VENDOR_ID_LENGTH DUP(?)
    ProductId    DB PRODUCT_ID_LENGTH DUP(?)
    Revision     DB REVISION_LENGTH DUP(?)
    SerialNumber DB SERIAL_NUMBER_LENGTH DUP(?)
    DeviceType   DB ?
CHANGER_PRODUCT_DATA ENDS

CHANGER_SET_ACCESS STRUCT ALIGNMODE
    Element CHANGER_ELEMENT <>
    Control DD ?
CHANGER_SET_ACCESS ENDS

CHANGER_READ_ELEMENT_STATUS STRUCT ALIGNMODE
    ElementList   CHANGER_ELEMENT_LIST <>
    VolumeTagInfo DD ?
CHANGER_READ_ELEMENT_STATUS ENDS

CHANGER_ELEMENT_STATUS STRUCT ALIGNMODE
    Element           CHANGER_ELEMENT <>
    SrcElementAddress CHANGER_ELEMENT <>
    Flags             DD ?
    ExceptionCode     DD ?
    TargetId          DB ?
    Lun               DB ?
    Reserved          DW ?
    PrimaryVolumeID   DB MAX_VOLUME_ID_SIZE DUP(?)
    AlternateVolumeID DB MAX_VOLUME_ID_SIZE DUP(?)
CHANGER_ELEMENT_STATUS ENDS

CHANGER_INITIALIZE_ELEMENT_STATUS STRUCT ALIGNMODE
    ElementList CHANGER_ELEMENT_LIST <>
    BarCodeScan DD ?
CHANGER_INITIALIZE_ELEMENT_STATUS ENDS

CHANGER_SET_POSITION STRUCT ALIGNMODE
    Transport   CHANGER_ELEMENT <>
    Destination CHANGER_ELEMENT <>
    Flip        DD ?
CHANGER_SET_POSITION ENDS

CHANGER_EXCHANGE_MEDIUM STRUCT ALIGNMODE
    Transport    CHANGER_ELEMENT <>
    Source       CHANGER_ELEMENT <>
    Destination1 CHANGER_ELEMENT <>
    Destination2 CHANGER_ELEMENT <>
    Flip1        DD ?
    Flip2        DD ?
CHANGER_EXCHANGE_MEDIUM ENDS

CHANGER_MOVE_MEDIUM STRUCT ALIGNMODE
    Transport   CHANGER_ELEMENT <>
    Source      CHANGER_ELEMENT <>
    Destination CHANGER_ELEMENT <>
    Flip        DD ?
CHANGER_MOVE_MEDIUM ENDS

CHANGER_SEND_VOLUME_TAG_INFORMATION STRUCT ALIGNMODE
    StartingElement  CHANGER_ELEMENT <>
    ActionCode       DD ?
    VolumeIDTemplate DB MAX_VOLUME_TEMPLATE_SIZE DUP(?)
CHANGER_SEND_VOLUME_TAG_INFORMATION ENDS

READ_ELEMENT_ADDRESS_INFO STRUCT ALIGNMODE
    NumberOfElements DD ?
    ElementStatus    CHANGER_ELEMENT_STATUS <>
READ_ELEMENT_ADDRESS_INFO ENDS

PATHNAME_BUFFER STRUCT ALIGNMODE
    PathNameLength DD ?
    _Name          DW ?
PATHNAME_BUFFER ENDS

FSCTL_QUERY_FAT_BPB_BUFFER STRUCT ALIGNMODE
    First0x24BytesOfBootSector DB 024H DUP(?)
FSCTL_QUERY_FAT_BPB_BUFFER ENDS

IFNDEF NTFS_VOLUME_DATA_BUFFER
    NTFS_VOLUME_DATA_BUFFER Struct ALIGNMODE
        VolumeSerialNumber           DQ ?
        NumberSectors                DQ ?
        TotalClusters                DQ ?
        FreeClusters                 DQ ?
        TotalReserved                DQ ?
        BytesPerSector               DD ?
        BytesPerCluster              DD ?
        BytesPerFileRecordSegment    DD ?
        ClustersPerFileRecordSegment DD ?
        MftValidDataLength           DQ ?
        MftStartLcn                  DQ ?
        Mft2StartLcn                 DQ ?
        MftZoneStart                 DQ ?
        MftZoneEnd                   DQ ?
    NTFS_VOLUME_DATA_BUFFER EndS
ENDIF

NTFS_EXTENDED_VOLUME_DATA STRUCT ALIGNMODE
    ByteCount    DD ?
    MajorVersion DW ?
    MinorVersion DW ?
NTFS_EXTENDED_VOLUME_DATA ENDS

STARTING_LCN_INPUT_BUFFER STRUCT ALIGNMODE
    StartingLcn DQ ?
STARTING_LCN_INPUT_BUFFER ENDS

VOLUME_BITMAP_BUFFER STRUCT ALIGNMODE
    StartingLcn DQ ?
    BitmapSize  DQ ?
    Buffer      DB ?
VOLUME_BITMAP_BUFFER ENDS

STARTING_VCN_INPUT_BUFFER STRUCT ALIGNMODE
    StartingVcn DQ ?
STARTING_VCN_INPUT_BUFFER ENDS

RETRIEVAL_POINTERS_BUFFER STRUCT ALIGNMODE
    ExtentCount DD ?
    StartingVcn DQ ?
    STRUCT Extents
        NextVcn DQ ?
        Lcn     DQ ?
    ENDS
RETRIEVAL_POINTERS_BUFFER ENDS

NTFS_FILE_RECORD_INPUT_BUFFER STRUCT ALIGNMODE
    FileReferenceNumber DQ ?
NTFS_FILE_RECORD_INPUT_BUFFER ENDS

NTFS_FILE_RECORD_OUTPUT_BUFFER STRUCT ALIGNMODE
    FileReferenceNumber DQ ?
    FileRecordLength    DD ?
    FileRecordBuffer    DB ?
NTFS_FILE_RECORD_OUTPUT_BUFFER ENDS

MOVE_FILE_DATA STRUCT ALIGNMODE
    FileHandle   DD ?
    StartingVcn  DQ ?
    StartingLcn  DQ ?
    ClusterCount DD ?
MOVE_FILE_DATA ENDS

IFDEF APP_WIN64
    MOVE_FILE_DATA32 STRUCT ALIGNMODE
        FileHandle   DD ?
        StartingVcn  DQ ?
        StartingLcn  DQ ?
        ClusterCount DD ?
    MOVE_FILE_DATA32 ENDS

    MARK_HANDLE_INFO32 STRUCT ALIGNMODE
        UsnSourceInfo DD ?
        VolumeHandle  DD ?
        HandleInfo    DD ?
    MARK_HANDLE_INFO32 ENDS
ENDIF

HFS_INFORMATION_BUFFER STRUCT ALIGNMODE
    FinderInfo DB 32 DUP(?)
HFS_INFORMATION_BUFFER ENDS

FIND_BY_SID_DATA STRUCT ALIGNMODE
    Restart DD ?
    Sid     SID <>
FIND_BY_SID_DATA ENDS

MFT_ENUM_DATA STRUCT ALIGNMODE
    StartFileReferenceNumber DQ ?
    LowUsn                   DQ ?
    HighUsn                  DQ ?
MFT_ENUM_DATA ENDS

CREATE_USN_JOURNAL_DATA STRUCT ALIGNMODE
    MaximumSize     DQ ?
    AllocationDelta DQ ?
CREATE_USN_JOURNAL_DATA ENDS

READ_USN_JOURNAL_DATA STRUCT ALIGNMODE
    StartUsn          DQ ?
    ReasonMask        DD ?
    ReturnOnlyOnClose DD ?
    Timeout           DQ ?
    BytesToWaitFor    DQ ?
    UsnJournalID      DQ ?
READ_USN_JOURNAL_DATA ENDS

USN_RECORD STRUCT ALIGNMODE
    RecordLength              DD ?
    MajorVersion              DW ?
    MinorVersion              DW ?
    FileReferenceNumber       DQ ?
    ParentFileReferenceNumber DQ ?
    Usn                       DQ ?
    TimeStamp                 DQ ?
    Reason                    DD ?
    SourceInfo                DD ?
    SecurityId                DD ?
    FileAttributes            DD ?
    FileNameLength            DQ ?
    FileNameOffset            DW ?
    FileName                  DW ?
USN_RECORD ENDS

USN_JOURNAL_DATA STRUCT ALIGNMODE
    UsnJournalID    DQ ?
    FirstUsn        DQ ?
    NextUsn         DQ ?
    LowestValidUsn  DQ ?
    MaxUsn          DQ ?
    MaximumSize     DQ ?
    AllocationDelta DQ ?
USN_JOURNAL_DATA ENDS

DELETE_USN_JOURNAL_DATA STRUCT ALIGNMODE
    UsnJournalID DQ ?
    DeleteFlags  DD ?
DELETE_USN_JOURNAL_DATA ENDS

MARK_HANDLE_INFO STRUCT ALIGNMODE
    UsnSourceInfo DD ?
    VolumeHandle  DD ?
    HandleInfo    DD ?
MARK_HANDLE_INFO ENDS

BULK_SECURITY_TEST_DATA STRUCT ALIGNMODE
    DesiredAccess DD ?
    SecurityIds   DD ?
BULK_SECURITY_TEST_DATA ENDS

FILESYSTEM_STATISTICS STRUCT ALIGNMODE
    FileSystemType          DW ?
    Version                 DW ?
    SizeOfCompleteStructure DD ?
    UserFileReads           DD ?
    UserFileReadBytes       DD ?
    UserDiskReads           DD ?
    UserFileWrites          DD ?
    UserFileWriteBytes      DD ?
    UserDiskWrites          DD ?
    MetaDataReads           DD ?
    MetaDataReadBytes       DD ?
    MetaDataDiskReads       DD ?
    MetaDataWrites          DD ?
    MetaDataWriteBytes      DD ?
    MetaDataDiskWrites      DD ?
FILESYSTEM_STATISTICS ENDS

FAT_STATISTICS STRUCT ALIGNMODE
    CreateHits          DD ?
    SuccessfulCreates   DD ?
    FailedCreates       DD ?
    NonCachedReads      DD ?
    NonCachedReadBytes  DD ?
    NonCachedWrites     DD ?
    NonCachedWriteBytes DD ?
    NonCachedDiskReads  DD ?
    NonCachedDiskWrites DD ?
FAT_STATISTICS ENDS

EXFAT_STATISTICS STRUCT ALIGNMODE
    CreateHits          DD ?
    SuccessfulCreates   DD ?
    FailedCreates       DD ?
    NonCachedReads      DD ?
    NonCachedReadBytes  DD ?
    NonCachedWrites     DD ?
    NonCachedWriteBytes DD ?
    NonCachedDiskReads  DD ?
    NonCachedDiskWrites DD ?
EXFAT_STATISTICS ENDS

NTFS_STATISTICS STRUCT ALIGNMODE
    LogFileFullExceptions              DD ?
    OtherExceptions                    DD ?
    MftReads                           DD ?
    MftReadBytes                       DD ?
    MftWrites                          DD ?
    MftWriteBytes                      DD ?
    STRUCT MftWritesUserLevel
        Write                          DW ?
        Create                         DW ?
        SetInfo                        DW ?
        Flush                          DW ?
    ENDS
    MftWritesFlushForLogFileFull       DW ?
    MftWritesLazyWriter                DW ?
    MftWritesUserRequest               DW ?
    Mft2Writes                         DD ?
    Mft2WriteBytes                     DD ?
    STRUCT Mft2WritesUserLevel
        Write                          DW ?
        Create                         DW ?
        SetInfo                        DW ?
        Flush                          DW ?
    ENDS
    Mft2WritesFlushForLogFileFull      DW ?
    Mft2WritesLazyWriter               DW ?
    Mft2WritesUserRequest              DW ?
    RootIndexReads                     DD ?
    RootIndexReadBytes                 DD ?
    RootIndexWrites                    DD ?
    RootIndexWriteBytes                DD ?
    BitmapReads                        DD ?
    BitmapReadBytes                    DD ?
    BitmapWrites                       DD ?
    BitmapWriteBytes                   DD ?
    BitmapWritesFlushForLogFileFull    DW ?
    BitmapWritesLazyWriter             DW ?
    BitmapWritesUserRequest            DW ?
    STRUCT BitmapWritesUserLevel
        Write                          DW ?
        Create                         DW ?
        SetInfo                        DW ?
    ENDS
    MftBitmapReads                     DD ?
    MftBitmapReadBytes                 DD ?
    MftBitmapWrites                    DD ?
    MftBitmapWriteBytes                DD ?
    MftBitmapWritesFlushForLogFileFull DW ?
    MftBitmapWritesLazyWriter          DW ?
    MftBitmapWritesUserRequest         DW ?
    STRUCT MftBitmapWritesUserLevel
        Write                          DW ?
        Create                         DW ?
        SetInfo                        DW ?
        Flush                          DW ?
    ENDS
    UserIndexReads                     DD ?
    UserIndexReadBytes                 DD ?
    UserIndexWrites                    DD ?
    UserIndexWriteBytes                DD ?
    LogFileReads                       DD ?
    LogFileReadBytes                   DD ?
    LogFileWrites                      DD ?
    LogFileWriteBytes                  DD ?
    STRUCT Allocate
        Calls                          DD ?
        Clusters                       DD ?
        Hints                          DD ?
        RunsReturned                   DD ?
        HintsHonored                   DD ?
        HintsClusters                  DD ?
        Cache                          DD ?
        CacheClusters                  DD ?
        CacheMiss                      DD ?
        CacheMissClusters              DD ?
    ENDS
NTFS_STATISTICS ENDS

FILE_OBJECTID_BUFFER STRUCT ALIGNMODE
    ObjectId              DB 16 DUP(?)
    UNION
        STRUCT ExtendedInfostruct
            BirthVolumeId DB 16 DUP(?)
            BirthObjectId DB 16 DUP(?)
            DomainId      DB 16 DUP(?)
        ENDS
        ExtendedInfo      DB 48 DUP(?)
    ENDS
FILE_OBJECTID_BUFFER ENDS

FILE_SET_SPARSE_BUFFER STRUCT ALIGNMODE
    SetSparse DD ?
FILE_SET_SPARSE_BUFFER ENDS

FILE_ZERO_DATA_INFORMATION STRUCT ALIGNMODE
    FileOffset      DQ ?
    BeyondFinalZero DQ ?
FILE_ZERO_DATA_INFORMATION ENDS

FILE_ALLOCATED_RANGE_BUFFER STRUCT ALIGNMODE
    FileOffset DQ ?
    _Length    DQ ?
FILE_ALLOCATED_RANGE_BUFFER ENDS

ENCRYPTION_BUFFER STRUCT ALIGNMODE
    EncryptionOperation DD ?
    _Private            DB ?
ENCRYPTION_BUFFER ENDS

DECRYPTION_STATUS_BUFFER STRUCT ALIGNMODE
    NoEncryptedStreams DD ?
DECRYPTION_STATUS_BUFFER ENDS

REQUEST_RAW_ENCRYPTED_DATA STRUCT ALIGNMODE
    FileOffset DQ ?
    _Length    DD ?
REQUEST_RAW_ENCRYPTED_DATA ENDS

ENCRYPTED_DATA_INFO STRUCT ALIGNMODE
    StartingFileOffset         DQ ?
    OutputBufferOffset         DD ?
    BytesWithinFileSize        DD ?
    BytesWithinValidDataLength DD ?
    CompressionFormat          DW ?
    DataUnitShift              DB ?
    ChunkShift                 DB ?
    ClusterShift               DB ?
    EncryptionFormat           DB ?
    NumberOfDataBlocks         DW ?
    DataBlockSize              DD ?
ENCRYPTED_DATA_INFO ENDS

SI_COPYFILE STRUCT ALIGNMODE
    SourceFileNameLength      DD ?
    DestinationFileNameLength DD ?
    Flags                     DD ?
    FileNameBuffer            DW ?
SI_COPYFILE ENDS

NSS_CONTROL STRUCT ALIGNMODE
    code  DD ?
    param DD ?
NSS_CONTROL ENDS

DISK_EXTENT STRUCT ALIGNMODE
    DiskNumber     DD ?
    StartingOffset DQ ?
    ExtentLength   DQ ?
DISK_EXTENT ENDS

VOLUME_DISK_EXTENTS STRUCT ALIGNMODE
    NumberOfDiskExtents DD ?
    Extents             DISK_EXTENT <>
VOLUME_DISK_EXTENTS ENDS

ENDIF ;WINIOCTL_INC
